/*********************************************************************

CSE/ENGR 142
Title:               Shipping
Date:                04/23/99

Author:              your name here
Student ID:          your ID number here
E-mail:              your e-mail address here

*********************************************************************/

/*
To avoid lines being wrapped on the turn-in receipt print-out, make
sure none of your lines are longer than this line (70
characters/columns):
---------------------------------------------------------------------- 
*/

#define FLAT_TAXI 1.65
#define TAXI_MILE 0.10
#define ADD_PASSENGERS 1.00
#define CARGO_FEE 0.02
#define HAZARDOUS_FEE 0.2
#define FLAT_HAZARDOUS 20.0
#define MAX_RANGE 100.0
#define SPEED 25.0

#include <stdio.h>
#include <math.h>

int delivery_choice(double total);
double distance(void);
double taxi(void);
double cargo(void);
double hazardous(void);

int main(void)
{
	/* Declare all variables needed by main. */
	
	/* needed only at the end to hold char pressed by user */
	char dummy_char;  
	
	double total_charges = 0;
	int choice = delivery_choice(total_charges);
	int previous_x = 0, previous_y = 0;

	while (choice != 0)
	{
		if (choice == 1) total_charges += taxi();
		if (choice == 2) total_charges += cargo();
		if (choice == 3) total_charges += hazardous();
		
		choice = delivery_choice(total_charges);
	}

	/* use the following if the window closes too soon: */
	printf("\n\nPress any key and then ENTER to end\n");
	scanf("%c%c", &dummy_char,&dummy_char);
	
	return 0;
}


int delivery_choice(double total)
{
	int choice = -1;

	while (choice < 0 || choice > 3)
	{
		printf("\n*********************************************************************\n");
		printf("Total charges so far: $%.2f\n\n", total);
		printf("0 to exit\n");
		printf("1 = person\n");
		printf("2 = cargo\n");
		printf("3 = hazardous load\n");
		printf("What type of cargo do you want to transport?  ");
		scanf("%d", &choice);
		if (choice < 0 || choice > 3) printf("INVALID INPUT!\n");
	}
	return choice;
}


double distance(void)
{
	int source_x, source_y, dest_x, dest_y;
	double radius = MAX_RANGE + 1;
	int hours, minutes;

	printf("Now we need to know where you are traveling...\n\n");
	while (radius > MAX_RANGE)
	{		
		printf("What is the x coordinate of your starting location?  ");
		scanf("%d", &source_x);
		printf("What is the y coordinate of your starting location?  ");
		scanf("%d", &source_y);
		radius = sqrt((source_x * source_x) + (source_y * source_y));
		if (radius > MAX_RANGE) 
		{
			printf("Sorry, we cannot make this delivery...\n");
			printf("We always stay within %.0f miles of our home base!\n\n", MAX_RANGE);
		}
	}
	hours = (int) (radius/SPEED);
	minutes = (int) (((radius - hours*SPEED)/SPEED) * 60);
	printf("It will take %d hours and %d minutes for our company to send a truck\n", hours, minutes);
	printf("to this location (our trucks travel at an average of 25 miles per hour).\n\n");
	
	radius = MAX_RANGE + 1;
	while (radius > MAX_RANGE)
	{	
		printf("What is the x coordinate of your ending location?  ");
		scanf("%d", &dest_x);
		printf("What is the y coordinate of your ending location?  ");
		scanf("%d", &dest_y);
		radius = sqrt((dest_x * dest_x) + (dest_y * dest_y));
		if (radius > MAX_RANGE) 
		{
			printf("Sorry, we cannot make this delivery...\n");
			printf("We always stay within %.0f miles of our home base!\n\n", MAX_RANGE);
		}
	}

	return sqrt((dest_y - source_y)*(dest_y - source_y) + 
				(dest_x - source_x)*(dest_x - source_x));

}


double taxi(void)
{
	int passengers = -1;
	double dist, fare;
	
	printf("\nThe fare is a flat rate of $%.2f plus $%.2f for each mile.\n", FLAT_TAXI, TAXI_MILE);
	printf("There's an additional charge of $%.2f for each additional passenger.\n", ADD_PASSENGERS);
	while (passengers < 0)
	{
		printf("How many other people are traveling with you?  ");
		scanf("%d", &passengers);
		if (passengers < 0) printf("INVALID number of passengers\n");
	}
	dist = distance();
	fare = FLAT_TAXI + TAXI_MILE * dist + passengers*ADD_PASSENGERS;
	printf("\nYour total taxi fare is:\n");
	printf("$%.2f + ($%.2f per mile)(%.3f miles) + $%.2f = $%.2f\n",
			FLAT_TAXI, TAXI_MILE, dist, passengers*ADD_PASSENGERS, fare);

	return fare;
}

double cargo(void)
{
	double kg = -1;
	double dist, cost;

	printf("\nFor each mile, there's a fee of $%.2f per kilogram of cargo transported.\n", CARGO_FEE);
	while (kg < 0)
	{
		printf("How many kilograms of cargo do you want to move?  ");
		scanf("%lf", &kg);
		if (kg < 0) printf("INVALID cargo weight!\n");
	}
	dist = distance();
	cost = kg * CARGO_FEE * dist;
	printf("\nYour total cargo fare is:\n");
	printf("(%.1f kgs) * ($%.2f per kg per mile) * (%.3f miles) = $%.2f\n",
			kg, CARGO_FEE, dist, cost);
	
	return cost;
}

double hazardous(void)
{
	double kg = -1;
	double dist, cost;

	printf("\nFor insurance purposes, there's a flat fee of $%.2f for hazardous handling.\n", FLAT_HAZARDOUS);
	printf("For each mile, there's a fee of $%.2f per kilogram of hazardous transportation.\n", HAZARDOUS_FEE);
	while (kg < 0)
	{
		printf("How many kilograms of hazardous cargo do you want to move?  ");
		scanf("%lf", &kg);
		if (kg < 0) printf("INVALID weight for hazardous cargo!\n");
	}
	dist = distance();
	cost = FLAT_HAZARDOUS + kg * HAZARDOUS_FEE * dist;
	printf("\nYour total hazardous load fare is:\n"); 
	printf("$%.2f + (%.1f kgs) * ($%.2f per kg per mile) * (%.3f miles) = $%.2f\n",
			FLAT_HAZARDOUS, kg, HAZARDOUS_FEE, dist, cost);
	
	return cost;
}




